; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 800
WINDOWHEIGHT = 800
yrot	equ xrot+4
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write


        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	mov	ecx,texture
	invoke	GlobalFree
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
@@:	cmp	al,VK_LEFT
	movd	xmm0,yrot
	movd	xmm1,const0_2
	jne	@f
	subss	xmm0,xmm1;  
	jmp	@1
@@:	cmp	al,VK_RIGHT
	jne	@f
	addss	xmm0,xmm1;  
@1:	movd	yrot,xmm0
	jmp	@0
@@:	cmp	al,VK_UP
	movd	xmm0,xrot
	jne	@f
	subss	xmm0,xmm1; xspeed
	jmp	@2
@@:	cmp	al,VK_DOWN
	jne	wmBYE
	addss	xmm0,xmm1; xspeed
@2:	movd	xrot,xmm0
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
        mov	ecx,offset FileName2
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
        FILE_FLAG_SEQUENTIAL_SCAN,0;;FILE_ATTRIBUTE_ARCHIVE,0
        mov	esi,eax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	texture,eax
        mov	edi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,esi,eax,FSize,,rbx
        invoke	CloseHandle,esi
	mov	esi,edi
        add	esi,[rdi + BITMAPFILEHEADER.bfOffBits]
	lea	edi,[rdi + sizeof BITMAPFILEHEADER]
	mov	eax,[rdi + BITMAPINFOHEADER.biWidth]
        mov	w,eax
        movzx	eax, word ptr [rdi + BITMAPINFOHEADER.biHeight]
        mov	h,eax
;--------------------------------------------------------------
	mov	edx,offset Texture1_Id
	invoke	glGenTextures,1
;    
	invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id
	mov	r9d,w
        mov	eax,h
	invoke	glTexImage2D,GL_TEXTURE_2D,0,3,,rax,rbx,GL_BGR_EXT,GL_UNSIGNED_BYTE,rsi
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR

        invoke	BuildLists
        invoke	glEnable,GL_TEXTURE_2D;enable texture mapping (the img is 2D)
	invoke	glShadeModel,GL_SMOOTH;smooth shading
	cvtss2sd xmm0,const1
	invoke	glClearDepth;   
	movd	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;    

	invoke	glEnable,GL_DEPTH_TEST ;  
	invoke	glDepthFunc,GL_LEQUAL ;  
	invoke	glEnable, GL_LIGHT0              ;dirty lighting
	invoke	glEnable, GL_LIGHTING            ;enable lighting
	invoke	glEnable, GL_COLOR_MATERIAL      ;enable material coloring
;     ()
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
        invoke	glBlendFunc,GL_SRC_ALPHA,GL_ONE;Set The Blending Function For Translucency
	invoke	glEnable,GL_BLEND
;     
	invoke	glMatrixMode,GL_PROJECTION;     ()
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT;clear screen before drawing
	invoke	glBindTexture,GL_TEXTURE_2D,Texture1_Id

    	mov	esi,1
@3:	xor	edi,edi
@4:	invoke glLoadIdentity
	cvtsi2ss xmm1,esi
	mulss	xmm1,const1_4
	cvtsi2ss xmm0,edi
	mulss	xmm0,const2_8
	addss	xmm0,const1_4
	subss	xmm0,xmm1 ;1.4 + xloop * 2.8 - yloop * 1.4
	cvtsi2ss xmm2,esi
	movss	xmm1,const6
	subss	xmm1,xmm2;yloop
	mulss	xmm1,const2_4
	subss	xmm1,const7;(6 - yloop)*2.4 - 7
	movss	xmm2,const_20
	invoke	glTranslatef
	cvtsi2ss xmm1,esi
        mulss	xmm1,const2
	xorps	xmm1,xmm1
	subss	xmm0,xmm1
	addss	xmm0,const45
	addss	xmm0,xrot
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	invoke	glRotatef 
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,xrot+4
	addss	xmm0,const45
	invoke	glRotatef
	mov	ecx,esi
	dec	ecx
	imul	ecx,12
	mov	w,ecx
	add	ecx,offset boxcol
	invoke	glColor3fv
	mov	ecx,box
        invoke	glCallList
	mov	ecx,w
	add	ecx, offset topcol
	invoke	glColor3fv
	mov	ecx,top
	invoke	glCallList
	inc	edi
	cmp	edi,esi
        jb	@4
        inc	esi
	cmp	esi,6
	jb	@3
        invoke  glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp

BuildLists PROC             ;build our cube display lists
	enter	40h,0
	invoke	glGenLists,2    ;we want 2 lists
	mov	box,eax            ;now box points to the first one
	invoke	glNewList,eax,GL_COMPILE   ;GL_COMPILE is important, see Nehe's tut for this
	invoke	glBegin,GL_QUADS            ;start a new QUAD
;bottom face
	xorps	xmm2,xmm2
	movss	xmm1,const_1
	xorps	xmm0,xmm0
    	invoke	glNormal3f        
	movss	xmm1,const1
	movss	xmm0,xmm1;const1
    	invoke	glTexCoord2f 
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
    	invoke	glVertex3f;  const_1,const_1
	movss	xmm1,const1
	xorps	xmm0,xmm0
    	invoke	glTexCoord2f; , const1
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,const1
    	invoke	glVertex3f;   const1,const_1,const_1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
    	invoke	glTexCoord2f; , xorps xmm,xmm
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm2
    	invoke	glVertex3f;   const1,const_1, const1
	xorps	xmm1,xmm1
	movss	xmm0,const1
    	invoke	glTexCoord2f; const1, 
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm1
    	invoke	glVertex3f;  const_1,const_1, const1
;front face
	movss	xmm2,const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
    	invoke	glNormal3f
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
    	invoke	glTexCoord2f; xorps xmm,xmm, xorps xmm,xmm
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm1
    	invoke	glVertex3f;  const_1,const_1, const1
	xorps	xmm1,xmm1
	movss	xmm0,const1
    	invoke	glTexCoord2f; const1, xorps xmm,xmm
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm2
    	invoke	glVertex3f;   const1,const_1, const1
	movss	xmm1,const1
	movss	xmm0,xmm1
    	invoke	glTexCoord2f; const1, const1
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
    	invoke	glVertex3f;   const1, const1, const1
	movss	xmm1,const1
	xorps	xmm0,xmm0
    	invoke	glTexCoord2f ;, const1
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,const_1
    	invoke	glVertex3f;  const_1, const1, const1
;back face
	movss	xmm2,const_1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
    	invoke	glNormal3f; , xorps xmm,xmm,const_1       
	xorps	xmm1,xmm1
	movss	xmm0,const1
    	invoke	glTexCoord2f; const1, xorps xmm,xmm
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
    	invoke	glVertex3f;  const_1,const_1,const_1
	movss	xmm1,const1
	movss	xmm0,xmm1
    	invoke	glTexCoord2f; const1, const1
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm2
    	invoke	glVertex3f;  const_1, const1,const_1
	movss	xmm1,const1
	xorps	xmm0,xmm0
    	invoke	glTexCoord2f; , const1
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm1
    	invoke	glVertex3f;   const1, const1,const_1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
    	invoke	glTexCoord2f 
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,const1
    	invoke	glVertex3f;   const1,const_1,const_1
;right face
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const1
    	invoke	glNormal3f
	xorps	xmm1,xmm1
	movss	xmm0,const1
    	invoke	glTexCoord2f; const1, 
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,const1
    	invoke	glVertex3f;   const1,const_1,const_1
	movss	xmm1,const1
	movss	xmm0,xmm1
    	invoke	glTexCoord2f; const1, const1
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm1
    	invoke	glVertex3f;   const1, const1,const_1
	movss	xmm1,const1
	xorps	xmm0,xmm0
    	invoke	glTexCoord2f ;, const1
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
    	invoke	glVertex3f;   const1, const1, const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
    	invoke	glTexCoord2f 
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm2
    	invoke	glVertex3f;   const1,const_1, const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const_1
    	invoke	glNormal3f; const_1,        ;left face
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
    	invoke	glTexCoord2f 
	movss	xmm2,const_1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
    	invoke	glVertex3f;  const_1,const_1,const_1
	xorps	xmm1,xmm1
	movss	xmm0,const1
    	invoke	glTexCoord2f; const1, 
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm1
    	invoke	glVertex3f;  const_1,const_1, const1
	movss	xmm1,const1
	movss	xmm0,xmm1
    	invoke	glTexCoord2f; const1, const1
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,const_1
    	invoke	glVertex3f;  const_1, const1, const1
	movss	xmm1,const1
	xorps	xmm0,xmm0
    	invoke	glTexCoord2f; , const1
	movss	xmm2,const_1
	movss	xmm1,const1
	movss	xmm0,xmm2
    	invoke	glVertex3f;  const_1, const1,const_1

	invoke	glEnd
	invoke	glEndList   ;it's ok for this list
	mov	eax,box
	inc	eax
	mov	top,eax        ;storage for the top
	invoke	glNewList,eax,GL_COMPILE
	invoke	glBegin,GL_QUADS
	xorps	xmm2,xmm2
	movss	xmm1,const1 
	xorps	xmm0,xmm0
    	invoke	glNormal3f  

	movss	xmm1,const1 
	xorps	xmm0,xmm0
    	invoke	glTexCoord2f
	movss	xmm2,const_1 
	movss	xmm1,const1 
	movss	xmm0,xmm2
    	invoke	glVertex3f
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
    	invoke	glTexCoord2f  
	movss	xmm2,const1 
	movss	xmm1,xmm2
	movss	xmm0,const_1 
    	invoke	glVertex3f
	xorps	xmm1,xmm1
	movss	xmm0,const1 
    	invoke	glTexCoord2f
	movss	xmm2,const1 
	movss	xmm1,xmm2
	movss	xmm0,xmm2
    	invoke	glVertex3f
	movss	xmm1,const1 
	movss	xmm0,xmm1
    	invoke	glTexCoord2f
	movss	xmm2,const_1 
	movss	xmm1,const1 
	movss	xmm0,xmm1
    	invoke	glVertex3f
	invoke	glEnd
	invoke	glEndList
	leave
	retn
BuildLists ENDP
;---------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #12: Display Lists",0
FileName	db "br_Rabbit3.cur",0
FileName2	db "02.bmp",0
Texture1_Id	dq ?
texture		dd ?
box		dd ?
top		dd ?
;-----------------------------
boxcol          dd 1.0,0,0,1.0,0.5,0,1.0,1.0,0,0,1.0,0,0,1.0,1.0
topcol          dd 0.5,0,0,0.5,0.25,0,0.5,0.5,0,0,0.5,0,0,0.5,0.5
;float
const0_2	dd 0.2
const0_5	dd 0.5
const1		dd 1.0
const_1		dd -1.0
const1_4	dd 1.4
const2		dd 2.0
const2_4	dd 2.4
const2_8	dd 2.8
const6		dd 6.0
const7		dd 7.0
const_20	dd -20.0
const45		dd 45.0
;double
constd0_1	dq 0.1
constd45	dq 45.0
constd100	dq 100.0
align 16
xrot		dd 0,  0,  0,  0
speed		dd 1.4,1.4,1.4,0
end